<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/admin.php";
include_once "include/site.php";
include_once "include/common.php";

$database = site_prolog(PO_USER_TYPE_ADMIN);
$auth_handle = new $po_auth();

site_header($strings['generic_admin'] ." : ". $strings['admin_edit_user']);
site_navigator(9);
site_navigator_status(emit_a("admin.php", $strings['generic_admin'])." : ". $strings['admin_edit_user'], "");

theme_display_navigator_box_top($admin_data['users_n_clients']['idx'], $admin_data, "100%");

$user_id = $_REQUEST['user'];
$user_data = pg_fetch_row(pg_query($database, "
  select users.identifier, last_name, first_name, member_since, value, user_type.identifier, hide, email, username
    from users, user_type
   where users.type=user_type.identifier
     and users.identifier=$user_id"));

$user_preferences = pg_fetch_row(pg_query($database, "
  select get_user_pref($user_id, 'bulk_upload_enable'),
         get_user_pref($user_id, 'quota_size'),
         get_user_pref($user_id, 'quota_count'),
         get_user_pref($user_id, 'show_ads'),
         get_user_pref($user_id, 'local_bulk_upload_path')"));

if (!$user_preferences[4]) $user_preferences[4] = $po_options_default['local_bulk_upload_path'];
if (!$user_preferences[3]) $user_preferences[3] = $po_options_default['show_ads'];
if ($user_preferences[2] == '') $user_preferences[2] = $po_options_default['quota_count'];
if ($user_preferences[1] == '') $user_preferences[1] = $po_options_default['quota_size'];
if (!$user_preferences[0]) $user_preferences[0] = $po_options_default['bulk_upload_enable'];

$user_preferences[1] /= 1048576;

$all_user_types = pg_query($database, "
  select user_type.identifier, user_type.value
    from user_type");

print "<form method=\"post\" action=\"admin.user.edit.2.php\" accept-charset=\"".$strings['formats_encoding']."\">";
print "<table class=\"search\">\n";
print "<tr>\n";
print emit_th($strings['generic_name']);
print emit_td(emit_a(generate_link('user', $user_data[0]), "$user_data[1], $user_data[2]"));
print "</tr>\n";
print "<tr>\n";
print emit_th($strings['generic_type']);
print "<td>";
if ($po_user['id'] == $user_data[0]) {
  print $strings['generic_administrator'];
  print "<input type=\"hidden\" name=\"type\" value=\"".PO_USER_TYPE_ADMIN."\" />";
} else {
  print emit_combo("type", $all_user_types, $user_data[5], "", 1);
}
print "</td>";
print "</tr>\n";
print "<tr>\n";
print emit_th($strings['generic_hide']);
print emit_td(emit_enable_disable_combo("hide", $user_data[6]));
print "</tr>\n";
print "<tr>\n";
print emit_th($strings['user_email']);
print emit_td("<input align=\"right\" type=\"text\" name=\"email\" value=\"$user_data[7]\"/>");
print "</tr>\n";
print "<tr>\n";
print emit_th($strings['generic_username']);
print emit_td("<input align=\"right\" type=\"text\" name=\"username\" value=\"$user_data[8]\"/>");
print "</tr>\n";
print "<tr>\n";
print emit_th($strings['generic_bulk_upload']);
print emit_td(emit_enable_disable_combo("bulk_upload_enable", $user_preferences[0]));
print "</tr>\n";
print "<tr>\n";
print emit_th($strings['generic_quota_size']);
print emit_td("<input align=\"right\" type=\"text\" name=\"quota_size\" value=\"$user_preferences[1]\" size=\"7\"/> MB");
print "</tr>\n";
print "<tr>\n";
print emit_th($strings['generic_quota_count']);
print emit_td("<input align=\"right\" type=\"text\" name=\"quota_count\" value=\"$user_preferences[2]\" size=\"7\"/>");
print "</tr>\n";
print "<tr>\n";
print emit_th($strings['generic_show_ads']);
print emit_td(emit_enable_disable_combo("show_ads", $user_preferences[3]));
print "</tr>\n";
print "<tr>\n";
print emit_th($strings['import_local_bulk_path']);
print emit_td("<input align=\"right\" type=\"text\" name=\"local_path\" value=\"$user_preferences[4]\" size=\"30\"/>");
print "</tr>\n";

if ($auth_handle->can_change_pass === TRUE) {
  print "<tr>\n";
  print emit_th($strings['generic_password']);
  print "<td><input type=\"password\" name=\"password_1\" value=\"\"/></td>\n";

  print "</tr>\n";
  print "<tr>\n";
  print emit_th($strings['generic_password_again']);
  print "</td><td><input type=\"password\" name=\"password_2\" value=\"\"/></td>\n";
  print "</tr>\n";
}
print "</table>\n";

print "<input type=\"hidden\" name=\"user\" value=\"$user_id\"/>";
print $thm_elem['button.save.changes'];
print $thm_elem['button.clear'];
print $thm_elem['button.cancel'];
print "</form>";

theme_display_navigator_box_bottom("100%");

site_footer($database);
site_epilog($database);
?>
