<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

$code128Bits =
  array ( /* Code   A     B     C                 Pattern      */
    array (array ( ' ',  ' ',   0), array (1,1,0,1,1,0,0,1,1,0,0)),
    array (array ( '!',  '!',   1), array (1,1,0,0,1,1,0,1,1,0,0)),
    array (array ( '?',  '?',   2), array (1,1,0,0,1,1,0,0,1,1,0)),
    array (array ( '#',  '#',   3), array (1,0,0,1,0,0,1,1,0,0,0)),
    array (array ( '$',  '$',   4), array (1,0,0,1,0,0,0,1,1,0,0)),
    array (array ( '%',  '%',   5), array (1,0,0,0,1,0,0,1,1,0,0)),
    array (array ( '&',  '&',   6), array (1,0,0,1,1,0,0,1,0,0,0)),
    array (array ('\'', '\'',   7), array (1,0,0,1,1,0,0,0,1,0,0)),
    array (array ( '(',  '(',   8), array (1,0,0,0,1,1,0,0,1,0,0)),
    array (array ( ')',  ')',   9), array (1,1,0,0,1,0,0,1,0,0,0)),
    array (array ( '*',  '*',  10), array (1,1,0,0,1,0,0,0,1,0,0)),
    array (array ( '+',  '+',  11), array (1,1,0,0,0,1,0,0,1,0,0)),
    array (array ( ',',  ',',  12), array (1,0,1,1,0,0,1,1,1,0,0)),
    array (array ( '-',  '-',  13), array (1,0,0,1,1,0,1,1,1,0,0)),
    array (array ( '.',  '.',  14), array (1,0,0,1,1,0,0,1,1,1,0)),
    array (array ( '/',  '/',  15), array (1,0,1,1,1,0,0,1,1,0,0)),
    array (array ( '0',  '0',  16), array (1,0,0,1,1,1,0,1,1,0,0)),
    array (array ( '1',  '1',  17), array (1,0,0,1,1,1,0,0,1,1,0)),
    array (array ( '2',  '2',  18), array (1,1,0,0,1,1,1,0,0,1,0)),
    array (array ( '3',  '3',  19), array (1,1,0,0,1,0,1,1,1,0,0)),
    array (array ( '4',  '4',  20), array (1,1,0,0,1,0,0,1,1,1,0)),
    array (array ( '5',  '5',  21), array (1,1,0,1,1,1,0,0,1,0,0)),
    array (array ( '6',  '6',  22), array (1,1,0,0,1,1,1,0,1,0,0)),
    array (array ( '7',  '7',  23), array (1,1,1,0,1,1,0,1,1,1,0)),
    array (array ( '8',  '8',  24), array (1,1,1,0,1,0,0,1,1,0,0)),
    array (array ( '9',  '9',  25), array (1,1,1,0,0,1,0,1,1,0,0)),
    array (array ( ':',  ':',  26), array (1,1,1,0,0,1,0,0,1,1,0)),
    array (array ( ';',  ';',  27), array (1,1,1,0,1,1,0,0,1,0,0)),
    array (array ( '<',  '<',  28), array (1,1,1,0,0,1,1,0,1,0,0)),
    array (array ( '=',  '=',  29), array (1,1,1,0,0,1,1,0,0,1,0)),
    array (array ( '>',  '>',  30), array (1,1,0,1,1,0,1,1,0,0,0)),
    array (array ( '?',  '?',  31), array (1,1,0,1,1,0,0,0,1,1,0)),
    array (array ( '@',  '@',  32), array (1,1,0,0,0,1,1,0,1,1,0)),
    array (array ( 'A',  'A',  33), array (1,0,1,0,0,0,1,1,0,0,0)),
    array (array ( 'B',  'B',  34), array (1,0,0,0,1,0,1,1,0,0,0)),
    array (array ( 'C',  'C',  35), array (1,0,0,0,1,0,0,0,1,1,0)),
    array (array ( 'D',  'D',  36), array (1,0,1,1,0,0,0,1,0,0,0)),
    array (array ( 'E',  'E',  37), array (1,0,0,0,1,1,0,1,0,0,0)),
    array (array ( 'F',  'F',  38), array (1,0,0,0,1,1,0,0,0,1,0)),
    array (array ( 'G',  'G',  39), array (1,1,0,1,0,0,0,1,0,0,0)),
    array (array ( 'H',  'H',  40), array (1,1,0,0,0,1,0,1,0,0,0)),
    array (array ( 'I',  'I',  41), array (1,1,0,0,0,1,0,0,0,1,0)),
    array (array ( 'J',  'J',  42), array (1,0,1,1,0,1,1,1,0,0,0)),
    array (array ( 'K',  'K',  43), array (1,0,1,1,0,0,0,1,1,1,0)),
    array (array ( 'L',  'L',  44), array (1,0,0,0,1,1,0,1,1,1,0)),
    array (array ( 'M',  'M',  45), array (1,0,1,1,1,0,1,1,0,0,0)),
    array (array ( 'N',  'N',  46), array (1,0,1,1,1,0,0,0,1,1,0)),
    array (array ( 'O',  'O',  47), array (1,0,0,0,1,1,1,0,1,1,0)),
    array (array ( 'P',  'P',  48), array (1,1,1,0,1,1,1,0,1,1,0)),
    array (array ( 'Q',  'Q',  49), array (1,1,0,1,0,0,0,1,1,1,0)),
    array (array ( 'R',  'R',  50), array (1,1,0,0,0,1,0,1,1,1,0)),
    array (array ( 'S',  'S',  51), array (1,1,0,1,1,1,0,1,0,0,0)),
    array (array ( 'T',  'T',  52), array (1,1,0,1,1,1,0,0,0,1,0)),
    array (array ( 'U',  'U',  53), array (1,1,0,1,1,1,0,1,1,1,0)),
    array (array ( 'V',  'V',  54), array (1,1,1,0,1,0,1,1,0,0,0)),
    array (array ( 'W',  'W',  55), array (1,1,1,0,1,0,0,0,1,1,0)),
    array (array ( 'X',  'X',  56), array (1,1,1,0,0,0,1,0,1,1,0)),
    array (array ( 'Y',  'Y',  57), array (1,1,1,0,1,1,0,1,0,0,0)),
    array (array ( 'Z',  'Z',  58), array (1,1,1,0,1,1,0,0,0,1,0)),
    array (array ( '[',  '[',  59), array (1,1,1,0,0,0,1,1,0,1,0)),
    array (array ('\\', '\\',  60), array (1,1,1,0,1,1,1,1,0,1,0)),
    array (array ( ']',  ']',  61), array (1,1,0,0,1,0,0,0,0,1,0)),
    array (array ( '^',  '^',  62), array (1,1,1,1,0,0,0,1,0,1,0)),
    array (array ( '_',  '_',  63), array (1,0,1,0,0,1,1,0,0,0,0)),
    array (array (   0,  '`',  64), array (1,0,1,0,0,0,0,1,1,0,0)),
    array (array (   1,  'a',  65), array (1,0,0,1,0,1,1,0,0,0,0)),
    array (array (   2,  'b',  66), array (1,0,0,1,0,0,0,0,1,1,0)),
    array (array (   3,  'c',  67), array (1,0,0,0,0,1,0,1,1,0,0)),
    array (array (   4,  'd',  68), array (1,0,0,0,0,1,0,0,1,1,0)),
    array (array (   5,  'e',  69), array (1,0,1,1,0,0,1,0,0,0,0)),
    array (array (   6,  'f',  70), array (1,0,1,1,0,0,0,0,1,0,0)),
    array (array (   7,  'g',  71), array (1,0,0,1,1,0,1,0,0,0,0)),
    array (array (   8,  'h',  72), array (1,0,0,1,1,0,0,0,0,1,0)),
    array (array (   9,  'i',  73), array (1,0,0,0,0,1,1,0,1,0,0)),
    array (array (  10,  'j',  74), array (1,0,0,0,0,1,1,0,0,1,0)),
    array (array (  11,  'k',  75), array (1,1,0,0,0,0,1,0,0,1,0)),
    array (array (  12,  'l',  76), array (1,1,0,0,1,0,1,0,0,0,0)),
    array (array (  13,  'm',  77), array (1,1,1,1,0,1,1,1,0,1,0)),
    array (array (  14,  'n',  78), array (1,1,0,0,0,0,1,0,1,0,0)),
    array (array (  15,  'o',  79), array (1,0,0,0,1,1,1,1,0,1,0)),
    array (array (  16,  'p',  80), array (1,0,1,0,0,1,1,1,1,0,0)),
    array (array (  17,  'q',  81), array (1,0,0,1,0,1,1,1,1,0,0)),
    array (array (  18,  'r',  82), array (1,0,0,1,0,0,1,1,1,1,0)),
    array (array (  19,  's',  83), array (1,0,1,1,1,1,0,0,1,0,0)),
    array (array (  20,  't',  84), array (1,0,0,1,1,1,1,0,1,0,0)),
    array (array (  21,  'u',  85), array (1,0,0,1,1,1,1,0,0,1,0)),
    array (array (  22,  'v',  86), array (1,1,1,1,0,1,0,0,1,0,0)),
    array (array (  23,  'w',  87), array (1,1,1,1,0,0,1,0,1,0,0)),
    array (array (  24,  'x',  88), array (1,1,1,1,0,0,1,0,0,1,0)),
    array (array (  25,  'y',  89), array (1,1,0,1,1,0,1,1,1,1,0)),
    array (array (  26,  'z',  90), array (1,1,0,1,1,1,1,0,1,1,0)),
    array (array (  27,  '{',  91), array (1,1,1,1,0,1,1,0,1,1,0)),
    array (array (  28,  '|',  92), array (1,0,1,0,1,1,1,1,0,0,0)),
    array (array (  29,  '}',  93), array (1,0,1,0,0,0,1,1,1,1,0)),
    array (array (  30,  '~',  94), array (1,0,0,0,1,0,1,1,1,1,0)),
    array (array (  31,  127,  95), array (1,0,1,1,1,1,0,1,0,0,0)),
    array (array (  96,   96,  96), array (1,0,1,1,1,1,0,0,0,1,0)), /* FNC3 FNC3 96   */
    array (array (  97,   97,  97), array (1,1,1,1,0,1,0,1,0,0,0)), /* FNC2 FNC2 97   */
    array (array (  98,   98,  98), array (1,1,1,1,0,1,0,0,0,1,0)), /* SHFT SHFT 98   */
    array (array (  99,   99,  99), array (1,0,1,1,1,0,1,1,1,1,0)), /* SWC  SWC  99   */
    array (array ( 100,  100, 100), array (1,0,1,1,1,1,0,1,1,1,0)), /* SWB  FNC1 SWB  */
    array (array ( 101,  101, 101), array (1,1,1,0,1,0,1,1,1,1,0)), /* FNC1 SWA  SWA  */
    array (array ( 102,  102, 102), array (1,1,1,1,0,1,0,1,1,1,0)), /* FNC1 FNC1 FNC1 */
    array (array ( 103,  103, 103), array (1,1,0,1,0,0,0,0,1,0,0)), /* START A */
    array (array ( 104,  104, 104), array (1,1,0,1,0,0,1,0,0,0,0)), /* START B */
    array (array ( 105,  105, 105), array (1,1,0,1,0,0,1,1,1,0,0)), /* START C */
    array (array ( 106,  106, 106), array (1,1,0,0,0,1,1,1,0,1,0))  /* STOP add two more bars to the end 11 */
  );
?>
