<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  /* 
     This file contains configuration defaults.  Do NOT modify this 
     file; It will be automatically overwritten on future upgrades.
     Instead, please add configuration entries to 

 		src/include/config_site.php 
  */

  /* Do not remove this line */
include_once "vars.php";

// The PO site url -- Make sure it has a trailing '/'
$site_url = "http://localhost/po/";
// This appears in the titlebar on every page.
$site_title = "My Photo Organizer";

$pretty_urls = FALSE;

$ad_script = FALSE;  // in page header
$ad_script2 = FALSE; // in page footer 
$misc_script = FALSE; // in photo page footer

// Use google-hosted copies of various javascript stuffs to speed things up
$use_google_js = FALSE;

// A URL to the bug tracker or whatnot for this site
$bug_url = "http://bugs.shaftnet.org/";

/* Database connection details */

// Use a local database via UNIX socket (fast and secure, default)
$db_dsn = "dbname=po_db user=po_user password=po_password";

// Use a local database via IP (slower)
// $db_dsn = "host=127.0.0.1 port=5432 dbname=po_db user=po_user password=po_password";

// Use an external database via IP 
// $db_dsn = "host=128.61.15.251 port=5432 dbname=po_db user=po_user password=po_password";

/* End Database details */

// Use output compression?
$compress_pages = true;

// Allow bulk uploads from local filesystem?
$local_bulk_upload = false;

// absolute path to your image repository which
// is used to store all your image files
$image_repository_path = "/export/po_dev_image_repository";

// absolute path to where photo organizer should store sessions
// leave blank to use system default.
$po_session_lifetime = 0; /* use default, but otherwise in seconds */
$po_session_path = "";
$po_session_handler = "";  
$po_cookie_path = "/";

// Once can use memcached instead.  For example:
// $po_session_path = "tcp://localhost:11211/";
// $po_session_handler = "memcache";

// If you want to use memcache to cache non-session data, set it here:
//$po_memcache = array(array("localhost", 11211), array("localhost",11212));
$po_memcache = array();

// absolute path to your temporary directory which
// is used to store printed files while they are converted
// and to perform bulk uploads
$tmp_volume_path = "/tmp";

// ImageMagick convert tool
$sys_convert = "/usr/bin/convert";
// ImageMagick composite tool
$sys_composite = "/usr/bin/composite";
// Alternatively, if you want to use GraphicsMagick:
$sys_gm = "/usr/bin/gm";
$use_gm = FALSE;

// Dave Coffin's raw image decoder
$sys_dcraw = "/usr/local/bin/dcraw";

// Path to The GIMP
$sys_gimp = "/usr/bin/gimp";

// Path to mplayer
$sys_mplayer = "/usr/bin/mplayer";

// exiftool utility
$sys_exiftool = "/usr/bin/exiftool";

// UFRaw batch decoder
$sys_ufraw = "/usr/local/bin/ufraw-batch";

/* Raw decoders, in order of prescedence */
$raw_decoder = "dcraw,ufraw,exiftool"; 

// dcm2pnm tool from the dcmtk suite
$sys_dcm2pnm = "/usr/local/dicom/bin/dcm2pnm";

// PS2PDF - converts PS documents into PDF ones
$sys_ps2pdf  = "/usr/bin/ps2pdf";

// gtar - must support the -z and -j options
$sys_tar = "/bin/tar";

// unzip
$sys_unzip = "/usr/bin/unzip";

// unzip
$sys_7za = "/usr/bin/7za";

// zip
$sys_zip = "/usr/bin/zip";

/* If you want to use an external, parallelizable workers to process 
   photo imports, turn this on and adjust the options */
$external_workers = FALSE;  // or TRUE
$num_of_workers = 1;        // or the number of CPU cores you want to use.
$external_username = 'apache';   // user web server runs at
$external_groupname = 'apache';  // group web server runs at

/* Default options */
$po_options = array(
		    "lang" => "en_US",  /* See lang/ for your options */

		    "order_by" => 7,
		    "folder_order_by" => 2,
		    "photos_per_page" => 20,
		    "rows_list_view" => 20,
		    "photo_view" => "slide", // or 'list'

		    "tooltip_width" => 200,      # Theme overrides!

		    "scaled_generate" => "thumb,preview,preview2,preview3,full",   # DO NOT CHANGE!

		    "full_max_size" => 0,
		    "full_format" => 'jpg',
		    "full_quality" => 85,
		    "full_color_space" => "RGB",
		    "full_gamma" => 1,
		    "full_sharpen_sigma" => 2.0,
		    "full_sharpen_amount" => 1.2,
		    "full_sharpen_threshold" => 0.05,
		    "full_border_width" => 0,
		    "full_border_height" => 0,
		    "full_border_color" => "000000",
		    "full_watermark_brightness" => 0,
		    "full_watermark_location" => "center",
		    "full_copy_metadata" => 't',
		    "full_sizecode" => 4,       #  DO NOT CHANGE!

		    "preview_max_size" => 700,   # Fixed for now
		    "preview_format" => 'jpg',  # or 'png'
		    "preview_quality" => 85,
		    "preview_color_space" => "RGB",
		    "preview_gamma" => 1,
		    "preview_sharpen_sigma" => 0.5,
		    "preview_sharpen_amount" => 1.4,
		    "preview_sharpen_threshold" => 0.05,
		    "preview_border_width" => 0,
		    "preview_border_height" => 0,
		    "preview_border_color" => "000000",
		    "preview_watermark_brightness" => 0,
		    "preview_watermark_location" => "center",
		    "preview_copy_metadata" => 't',
		    "preview_sizecode" => 2,       #  DO NOT CHANGE!

		    "preview2_max_size" => 350,   # Fixed for now
		    "preview2_format" => 'jpg',  # or 'png'
		    "preview2_quality" => 85,
		    "preview2_color_space" => "RGB",
		    "preview2_gamma" => 1,
		    "preview2_sharpen_sigma" => 0.5,
		    "preview2_sharpen_amount" => 1.4,
		    "preview2_sharpen_threshold" => 0.05,
		    "preview2_border_width" => 0,
		    "preview2_border_height" => 0,
		    "preview2_border_color" => "000000",
		    "preview2_watermark_brightness" => 0,
		    "preview2_watermark_location" => "center",
		    "preview2_copy_metadata" => 't',
		    "preview2_sizecode" => 5,       #  DO NOT CHANGE!

		    "preview3_max_size" => 1050,   # Fixed for now
		    "preview3_format" => 'jpg',  # or 'png'
		    "preview3_quality" => 85,
		    "preview3_color_space" => "RGB",
		    "preview3_gamma" => 1,
		    "preview3_sharpen_sigma" => 0.5,
		    "preview3_sharpen_amount" => 1.4,
		    "preview3_sharpen_threshold" => 0.05,
		    "preview3_border_width" => 0,
		    "preview3_border_height" => 0,
		    "preview3_border_color" => "000000",
		    "preview3_watermark_brightness" => 0,
		    "preview3_watermark_location" => "center",
		    "preview3_copy_metadata" => 't',
		    "preview3_sizecode" => 6,       #  DO NOT CHANGE!
		    
		    "thumb_max_size" => 170,   # Fixed for now
		    "thumb_format" => 'jpg',  # or 'png'
		    "thumb_quality" => 85,
		    "thumb_color_space" => "RGB",
		    "thumb_gamma" => 1,
		    "thumb_sharpen_sigma" => 0.5,
		    "thumb_sharpen_amount" => 2.2,
		    "thumb_sharpen_threshold" => 0.00,
		    "thumb_border_width" => 0,
		    "thumb_border_height" => 0,
		    "thumb_border_color" => "000000",
		    "thumb_watermark_brightness" => 0,
		    "thumb_watermark_location" => "center",
		    "thumb_copy_metadata" => 'f',
		    "thumb_sizecode" => 1,       #  DO NOT CHANGE!

		    "watermark_photo" => 0,
		    "watermark_path" => '',

		    "colorspace" => 1, //from vars.php

		    "hide_originals_default" => 't',
		    "access_default" => PO_ACCESS_PUBLIC, 
		    "copyright_default" => '',    
		    "author_default" => '',
		    "web_statement_default" => '',  
		    "import_last_master" => 'f',

		    "ufraw_gamma" => 0.45,
		    "ufraw_gamma_linearity" => 0.10,
		    "dcraw_brightness" => 1.0,
		    "raw_white_balance" => "camera",
		    "raw_bitdepth" => 24,
		    "raw_denoise" => 0,  /* floating point, 0 = disable */
		    "jpgfromraw" => 't',
		    "jpgfromraw_master" => 'f',

		    "print_out" => "pdf",  // "ps" or "pdf"
		    "start_hour" => 8,
		    "end_hour" => 20,
		    "start_day" => 1, 
		    "paper" => 13,
		    "label" => 17,
		    "popup_enable" => 't',
		    "popup_delay" => 100,
		    "search_enable_stemming" => 'f',
		    "search_engine_type" => 1,
		    "search_masters_only" => 't',

		    "export_format" => "tar",  // "tar" or "zip"
		    "local_bulk_upload_path" => '', // Do *not* set globally!

		    "import_metadata_order" => "xmp,exif,iptc"
		    );

/* A few more things */
$po_options['focal_lengths'] = '5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 24, 28, 35, 40, 45, 50, 55, 60, 65,70, 75, 80, 85, 90, 95, 100, 105, 110, 115, 120, 125, 130, 135, 140, 145, 150, 180, 210, 240, 300, 400, 500, 600, 800, 1000, 1100, 1200, 1300, 1500';
$po_options['apertures'] = '0.5, 0.75, 1.0, 1.2, 1.3, 1.4, 1.8, 2.0, 2.2, 2.5, 2.8, 3.2, 3.5, 4.0, 4.5, 5.0, 5.6, 6.3, 7.1, 8, 9, 10, 11, 13, 14, 16, 18, 20, 22, 25, 28, 32, 36, 40, 45, 51, 57, 64, 72, 81, 90, 103, 115, 128';
$po_options['scan_bitdepths'] = '8, 12, 14, 15, 16, 18, 24, 32, 36, 48';
$po_options['scan_multiscans'] = '1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16';
$po_options['scan_resolutions'] = '50, 75, 90, 93, 96, 100, 103, 107, 111, 126, 120, 126, 131, 138, 145, 150, 152, 161, 170, 181, 193, 207, 223, 241, 263, 290, 300, 322, 362, 414, 483, 580, 600, 725, 800, 966, 1000, 1200, 1450, 1600, 1800, 2000, 2200, 2400, 2700, 2820, 2900, 3600, 4000, 4800, 9600';

/* We need this to track changes */
$po_options_default = array();

$po_options_default['new_user_type'] = PO_USER_TYPE_USER; 
$po_options_default['volume_max_size'] = 690; // MB
$po_options_default['volume_max_count'] = 0; // file count; 0 disables.
$po_options_default['bulk_upload_enable'] = 't';
$po_options_default['quota_size'] = 0;   // in bytes
$po_options_default['quota_count'] = 0;  // in files
$po_options_default['show_ads'] = 'f';
$po_options_default['theme'] = 'aqua';  // see themes/*



// You might want to add more forbidden keywords
$forbidden_keywords = array("a", "b", "c", "d", "e", "f", "g", "h",
                             "i", "j", "k", "l", "m", "n",  "o", "p",
                             "q", "r", "s", "t", "u", "v", "w", "x", "y", "z",
                             "on", "in", "the", "of", "to", "at", "an", "as");

/* Default error reporting level */
error_reporting(E_ALL ^ E_NOTICE);

/* Default credentials expiration time */
$default_cred_timeout = 60 * 10;  // 10 minutes

$po_version = "2.37-rc2";

include_once "auth.php";
$po_auth = "po_auth_default_db";

/* Do NOT modify anything below this line unless you know what you're doing */

include_once "Log.php";
$po_log = FALSE;
$po_log_level = PEAR_LOG_NOTICE;

$install_enabled = 0;

include_once "config_site.php";

$po_options['passwords'] = array();
$po_options['last_updated'] = '';

foreach ($po_options as $key => $value) {
  $po_options_default[$key] = $value;
}
  
$po_options['bulk_upload_enable'] = $po_options_default['bulk_upload_enable'];
$po_options['quota_size'] = $po_options_default['quota_size'];
$po_options['quota_count'] = $po_options_default['quota_count'];
$po_options['show_ads'] = $po_options_default['show_ads'];
$po_options['theme'] = $po_options_default['theme'];

/* Figure out the webroot. */
$webroot = strstr($site_url, "//");
$webroot = substr($webroot, 2);
$webroot = strstr($webroot, "/");

include_once "lang/en_US.php";

?>
