<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

function emit_event_combo($database, $identifier, $owner, $selected) {
  global $strings;

  $rval = "<select name=\"$identifier\">";

  $query = pg_query($database, "select identifier, start_date, end_date, remark from calendar where users = $owner");

  $rval .= emit_option("null", $strings['generic_none'], (!$selected));
    
  for ($i = 0 ; $i < pg_num_rows($query) ; $i++) {
    $data = pg_fetch_assoc($query, $i);
    $rval .= emit_option($data['identifier'], $data['remark'], $selected == $data['identifier']);
  }

  $rval .= "</select>\n";

  return $rval;
}

function emit_events_for_user($database, $owner, $client) {
  $rval = "";

  $query = pg_query($database, "select identifier, start_date, end_date, remark from calendar where users = $owner and client = $client");

  if (!$query)
    return $rval;

  for ($i = 0 ; $i < pg_num_rows($query) ; $i++) {
    $data = pg_fetch_assoc($query, $i);
    $rval .= "<tr>";
    $rval .= emit_td(emit_date_html($data['start_date'], "date", TRUE));
    $rval .= emit_td(emit_date_html($data['start_date'], "time") ." - ". emit_date_html($data['end_date'], "time"));
    $rval .= emit_td(emit_a("event.php?event=$data[identifier]", $data['remark']));
    $rval .= "</tr>";
  }
  if ($i > 0) {
    $rval = "<table>$rval</table>";
  }

  return $rval;
}

function display_clients($database, $my_user_id, $auth_handle) {
  global $strings;
  global $po_user;
  global $client_status;

  print "<table class=\"profile\">\n";
  print "<tr class=\"folder_top\">\n";
  print emit_td($strings['datebook_my_contacts'], 'colspan="6"');
  print "</tr>\n";
  print "<tr>\n";
  print emit_th($strings['generic_client_name'], 'width="50%"');
  print emit_th($strings['generic_status'], 'width="15%"');
  print emit_th($strings['generic_trusted'], 'width="10%"');
  print emit_th($strings['generic_reg_date'], 'width="15%"');
  if ($po_user['type'] >= PO_USER_TYPE_USER && ($auth_handle->local_register === TRUE)) {
    print emit_th(emit_a("register.php", $strings['generic_register']), 'width="10%" colspan="2"');
  } else {
    print emit_th('', 'width="10%" colspan="2"');
  }
  print "</tr>\n";

  $all_clients = pg_query($database, "select identifier, client, last_name, first_name, date_of_creation, value, type, trusted
                                        from view_client
                                       where users='$my_user_id'");
  $num_of_clients = pg_num_rows($all_clients);

  for ($i = 0; $i < $num_of_clients; $i++) {
    $client = pg_fetch_row($all_clients, $i);
    if ($client[2] != '' && $client[3] != '') {
      $client[2] = sprintf("%s,", $client[2]);
    }

    print "<tr>\n";
    print emit_td(emit_a(generate_link('user', $client[1]), "$client[2] $client[3]"));
    print emit_td($strings['generic_'.$client_status[$client[5]]]);
    print emit_td(emit_yes_no_text($client[7]));
    print emit_td(emit_date_html($client[4], 'date'));
    print emit_td(emit_a("client.edit.php?client=$client[0]", $strings['generic_edit']));
    print emit_td(emit_a("client.del.php?client=$client[0]", $strings['generic_delete']));
    print "</tr>\n";
    print "<tr><td colspan=\"6\" align=\"center\">";
    print emit_events_for_user($database, $my_user_id, $client[1]);
    print "</td></tr>";
  }

  print "</table>\n";
}

function display_protected_photographers($database, $my_user_id, $owner = FALSE) {
  global $strings;
  global $client_status;

  if ($owner) {
    $owner = " and users = $owner ";
  } else {
    $owner = "";
  }

  $all_subscribed_users = pg_query($database, " select identifier, users, last_name, first_name, date_of_creation, value from view_client where client='$my_user_id' and status!='4' $owner ");
  $num_of_subscribed_users = pg_num_rows($all_subscribed_users);

  if ($num_of_subscribed_users) {
    print "<table class=\"profile\">\n";
    print "<tr class=\"folder_top\">\n";
    print emit_td($strings['datebook_i_am_client_of'], 'colspan="4"');
    print "</tr>\n";
    print "<tr>\n";
    print emit_th($strings['generic_user'], 'width="50%"');
    print emit_th($strings['generic_status'], 'width="20%"');
    print emit_th($strings['generic_reg_date'], 'width="20%"');
    print emit_th('', 'width="10%"');
    print "</tr>\n";

    for ($i = 0; $i < $num_of_subscribed_users; $i++) {
      $subscribed_user = pg_fetch_row($all_subscribed_users, $i);
      if ($subscribed_user[2] != '' && $subscribed_user[3] != '') {
	$subscribed_user[2] = sprintf("%s,", $subscribed_user[2]);
      }
      print "<tr>\n";
      print emit_td(emit_a(generate_link('user', $subscribed_user[1]), "$subscribed_user[2] $subscribed_user[3]"));
      print emit_td($strings['generic_'.$client_status[$subscribed_user[5]]]);
      print emit_td(emit_date_html($subscribed_user[4], 'date'));
      print emit_td(emit_a("subscription.del.php?client=$subscribed_user[0]", $strings['generic_delete']));
      print "</tr>\n";
      print "<tr><td colspan=\"4\" align=\"center\">";
      print emit_events_for_user($database, $subscribed_user[1], $my_user_id);
      print "</td></tr>";
    }
    print "</table>\n";
  }
}

?>
