<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

$order_by_string = array();
$folder_order_by_string = array();

function orderby_i18n_data() {
  global $order_by_string;
  global $folder_order_by_string;
  global $strings;

  $order_by_string = array (
		    "0"  => array ("",  
				   $strings['generic_none']),
		    "1"  => array ("rating asc",  
				   $strings['generic_rating']. " &uarr;"),
		    "2"  => array ("rating desc",
				   $strings['generic_rating']. " &darr;"),
		    "3"  => array ("photo.views asc", 
				   $strings['generic_views']." &uarr;"),
		    "4"  => array ("photo.views desc", 
				   $strings['generic_views']." &darr;"),
		    "5"  => array ("photo_version.date_of_creation asc",
				   $strings['generic_created']." &uarr;"),
		    "6"  => array ("photo_version.date_of_creation desc",
				   $strings['generic_created']." &darr;"),
		    "7"  => array ("photo.date_of_exposure asc",
				   $strings['generic_exposed']." &uarr;"),
		    "8"  => array ("photo.date_of_exposure desc",
				   $strings['generic_exposed']." &darr;"),
		    "9"  => array ("photo_version.original_image_name asc",
				   $strings['generic_orig_file']. " &uarr;"),
		    "10" => array ("photo_version.original_image_name desc", 
				   $strings['generic_orig_file']." &darr;"),
		    "11" => array ("photo.caption asc",
				   $strings['generic_caption']." &uarr;"),
		    "12" => array ("photo.caption desc",
				   $strings['generic_caption']." &darr;"),
		    "13" => array ("photo.title asc",
				   $strings['generic_title']." &uarr;"),
		    "14" => array ("photo.title desc",
				   $strings['generic_title']." &darr;"),
		    "15" => array ("photo.identifier asc",
				   $strings['generic_order_added']." &uarr;"),
		    "16" => array ("photo.identifier desc",
				   $strings['generic_order_added']." &darr;"),
		    "17" => array ("photo.access_rights asc",
				   $strings['generic_access']." &uarr;"),
		    "18" => array ("photo.access_rights desc",
				   $strings['generic_access']." &darr;"),
		    "19" => array ("photo.users asc",
				   $strings['generic_user']." &uarr;"),
		    "20" => array ("photo.users desc",
				   $strings['generic_user']." &darr;"),
		    "21" => array ("random()",
				   $strings['generic_random']),
		    "22" => array ("album_content.date_added asc",
				   $strings['generic_order_added_album']." &uarr;"),
		    "23" => array ("album_content.date_added desc",
				   $strings['generic_order_added_album']." &darr;"));

  $folder_order_by_string = array (
		      "0"  => array ("",  
				     $strings['generic_none']),
                      "1"  => array ("date_of_creation asc",
				     $strings['generic_created']." &uarr;"),
		      "2"  => array ("date_of_creation desc",
				     $strings['generic_created']." &darr;"),
		      "3"  => array ("caption asc",
				     $strings['generic_caption']." &uarr;"),
		      "4"  => array ("caption desc",
				     $strings['generic_caption']." &darr;"),
		      "5"  => array ("date_changed asc",
				     $strings['generic_last_mod']." &uarr;"),
		      "6"  => array ("date_changed desc",
				     $strings['generic_last_mod']." &darr;"),
		      "7"  => array ("access_rights asc",
				     $strings['generic_access']." &uarr;"),
		      "8"  => array ("access_rights desc",
				     $strings['generic_access']." &darr;"),
		      "9"  => array ("photos asc",
				     $strings['generic_photos']." &uarr;"),
		      "10" => array ("photos desc",
				     $strings['generic_photos']." &darr;"),
		      "11" => array ("subs asc",
				     $strings['generic_subfolders']." &uarr;"),
		      "12" => array ("subs desc",
				     $strings['generic_subfolders']." &darr;"),
		      "13" => array ("users asc",
				     $strings['generic_user']." &uarr;"),
		      "14" => array ("users desc",
				     $strings['generic_user']." &darr;"),
		      "15" => array ("random()",
				     $strings['generic_random']));
}

$generate_i18n_data[] = "orderby_i18n_data";

function display_folder_order_by_combo($order_by) {
  global $folder_order_by_string;

  print "<select name=\"folder_order_by\">\n";
  for ($i = 0; $i < count($folder_order_by_string); $i++) {
    $string = $folder_order_by_string[$i][1];
    print emit_option($i, $string, $i == $order_by);
  }
  print "</select>\n";
}

function display_order_by_combo($order_by) {
  global $order_by_string;

  print "<select name=\"order_by\">\n";
  for ($i = 0; $i < count($order_by_string); $i++) {
    $string = $order_by_string[$i][1];
    print emit_option($i, $string, $i == $order_by);
  }
  print "</select>\n";
}

function display_order_by_combo_with_button($order_by) {
  global $thm_elem;
  global $order_by_string;

  print "<table>\n<tr>\n<td>\n";
  print $thm_elem['button.order.by'];
  print "</td>\n<td>\n";
  display_order_by_combo($order_by);
  print "</td></tr>";
  print "</table>";
}

?>
