<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/site.php";
include_once "include/import.php";

$database = FALSE;
$children = array();
$memcache = FALSE;

if (!$external_workers) {
  print "\$external_workers is FALSE.  set to TRUE to use me.\n";
  exit(1);
}

function child_fn() {
  global $database;
  global $memcache;
  global $po_memcache;

  $database = po_dbconnect();

  /* Connect to the memcache */
  if (count($po_memcache)) {
    $memcache = new Memcached;
    $memcache->addServers($po_memcache);
  }

  print "Starting Worker\n";
  while (TRUE) {
    photo_import_worker($database);
    sleep(10);
  }
  site_epilog($database);
}

function dofork() {
  global $children;

  $pid = pcntl_fork();
  /* Child */
  if ($pid == -1) {
    /* Gadzooks, something went wrong! */
  } else if ($pid == 0) {
    child_fn();
    exit();
  } else {
    /* Parent */
    $children["$pid"] = $pid;
    po_log("Photo worker started (total ".sizeof($children) .") PID $pid ");
  }
  return $pid;
}

if (!function_exists("pcntl_fork")) {
  print "PHP's PCNTL extension is not installed or enabled.\n";
  exit(1);
}

/* Disable execution limits */
ini_set("max_execution_time", "0");
ini_set("max_input_time", "0");
set_time_limit(0);

# look up info on configured user/group
$uinfo = posix_getpwnam($external_username);
$ginfo = posix_getgrnam($external_groupname);

if (($uinfo === FALSE) || ($ginfo == FALSE)) {
  print "Invalid username or groupname specified.\n";
  exit(1);  
}

if ((posix_getuid() != 0) &&
    (posix_getuid() != $uinfo['uid'])) {
  print "Needs to be run as root!  (Will drop privilges ASAP)\n";
  exit(1);
}

# drop privlidges!
posix_setgid($ginfo['gid']);
posix_setuid($uinfo['uid']);

/* Start up new children. */
for ($i = 0 ; $i < $num_of_workers ; $i++) {
  $pid = dofork();
}

/* Clean up after the children and restart them as necessary */
while(TRUE) {
  $foo = pcntl_wait($status, WUNTRACED);
  if ($foo > 0) {
    unset($children["$pid"]);
  }
  $pid = dofork();
}

exit();
