<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/color.php";
include_once "include/mail.php";
include_once "include/admin.php";

$user_id = FALSE;

$database = site_prolog();

$auth_handle = new $po_auth();

$username = isset($_REQUEST['username']) ? $_REQUEST['username'] : "";
$lang = isset($_REQUEST['lang']) ? $_REQUEST['lang'] : $po_options['lang'];
$first_name = isset($_REQUEST['first_name']) ? $_REQUEST['first_name'] : "";
$last_name = isset($_REQUEST['last_name']) ? $_REQUEST['last_name'] : "";
$email = isset($_REQUEST['email']) ? $_REQUEST['email'] : "";

if ($auth_handle->username_is_email === TRUE) {
  $email = $username;
 }

if (($auth_handle->local_register !== TRUE) ||
    (($po_options_default['new_user_type'] == PO_USER_TYPE_DISABLED) && 
     ($po_user['type'] < PO_USER_TYPE_USER))) {
  site_referer_error('registration_disabled');
  site_epilog($database);
  exit();
}

/* If we have a supplied username/password, try to register */
if ($username!="") {
  if (!$auth_handle->can_register($username)) {
    site_push_error($strings['errors_username_registered'] . ": <b>$username</b>"); // XXX need better...
  } elseif (($first_name == "") || ($last_name == "")) {
    site_push_error($strings['errors_names_mandatory']);
  } elseif ($email == "") {
    site_push_error($strings['errors_email_mandatory']);
  } else {
    /* Registration is OK! */
    if ($po_user['type'] == PO_USER_TYPE_ADMIN) {
      $user_type = $_REQUEST['new_user_type'];
    } elseif ($po_user['type'] == PO_USER_TYPE_USER) {
      $user_type = PO_USER_TYPE_CLIENT;
    } else {
      $user_type = $po_options_default['new_user_type'];
    }

    $password                     = generate_password();

    $user_id = register_user($database, $username, $user_type, $password, $first_name, $last_name, $email, $auth_handle);
    if ($user_id !== FALSE) {
      send_login_information($database, $email, $password, $username, $auth_handle);
    } else {
      site_push_error($strings['errors_db_insert_failed']);
    } 
  }
 }

/* Did a successful registration occur? */
if ($user_id !== FALSE) {
  if ($po_user['type'] == PO_USER_TYPE_ADMIN) {
    header("Location: admin.php?selector=2");
  } elseif ($po_user['type'] == PO_USER_TYPE_USER) {
    header("Location: my.datebook.php");
  } else {
    header("Location: $site_url/login.php?reason=registered");  
  }
  exit();
 }

/* Display the registration form */

site_header($strings['generic_register']);
site_navigator(3);
 
site_navigator_status("<a href=\"login.php\">".$strings['generic_login']."</a> : ".$strings['generic_user_registration'] , $strings['user_registration_text']);

$all_states = pg_query($database, "select identifier, value from state order by value");
$all_countries = pg_query($database, "select identifier, value from country order by value");

print "&nbsp;<br/>\n";
print "<form action=\"register.php\" method=\"post\" accept-charset=\"".$strings['formats_encoding']."\">\n";
print "<table class=\"search\">\n";
print "<tr><td><b>".$strings['generic_username']."</b></td><td><input tabindex=\"1\" type=\"text\" name=\"username\" value=\"$username\" size=\"35%\"/></td></tr>\n";
print "<tr><td><b>".$strings['user_first_name']."</b></td><td><input tabindex=\"4\" type=\"text\" name=\"first_name\" value=\"$first_name\" size=\"35%\"/></td></tr>\n";
print "<tr><td><b>".$strings['user_last_name']."</b></td><td><input tabindex=\"5\" type=\"text\" name=\"last_name\" value=\"$last_name\" size=\"35%\"/></td></tr>\n";
if ($auth_handle->username_is_email !== TRUE) {
  print "<tr><td><b>".$strings['user_email']."</b></td><td><input tabindex=\"6\" type=\"text\" name=\"email\" value=\"$email\" size=\"35%\"/></td></tr>\n";
 }

if ($po_user['type'] == PO_USER_TYPE_ADMIN) {
  $all_user_types = pg_query($database, "
  select user_type.identifier, user_type.value
    from user_type");
  print "<tr><td><b>".$strings['generic_type']."</b></td><td>";
  print emit_combo("new_user_type", $all_user_types, $po_options_default['new_user_type'], "", 1);
  print "</td></tr>\n";
 }

print emit_language_combo($lang);
print "<tr><td>".$strings['user_web']."</td><td><input tabindex=\"7\" type=\"text\" name=\"url\" value=\"$url\" size=\"35%\"/></td></tr>\n";
print "<tr><td>".$strings['user_phone']."</td><td><input tabindex=\"8\" type=\"text\" name=\"phone\" value=\"$phone\" size=\"35%\"/></td></tr>\n";
print "<tr><td>".$strings['user_company']."</td><td><input tabindex=\"9\" type=\"text\" name=\"company\" value=\"$company\" size=\"35%\"/></td></tr>\n";
print "<tr><td valign=\"center\" rowspan=\"2\" >".$strings['user_address']."</td><td><input tabindex=\"10\" type=\"text\" name=\"address1\" value=\"$address1\" size=\"35%\"/></td></tr><tr><td><input tabindex=\"11\" type=\"text\" name=\"address2\" value=\"$address2\" size=\"35%\"/></td></tr>\n";
print "<tr><td>".$strings['user_city']."</td><td><input tabindex=\"12\" type=\"text\" name=\"city\" value=\"$city\" size=\"35%\"/></td></tr>\n";
print "<tr><td>".$strings['user_post_code']."</td><td><input tabindex=\"13\" type=\"text\" name=\"zipcode\" value=\"$zipcode\" size=\"35%\"/></td></tr>\n";
print "<tr><td>".$strings['user_state']."</td><td>"; print emit_combo("state", $all_states, $state, "", 0); print"</td></tr>\n";
print "<tr><td>".$strings['user_country']."</td><td>"; print emit_combo("country", $all_countries, $country, "", 0); print"</td></tr>\n";
print "</table>\n";

print "<div align=\"center\">";
print "<p>".$strings['login_email_warning']."</p>";

print $thm_elem['button.register'];
print $thm_elem['button.clear'];
print $thm_elem['button.cancel'];
print "</div>";
print "</form>\n";

site_footer($database);
site_epilog($database);
?>
